TITLE	SETPIXEL.ASM -- ProBas CGA/EGA/VGA graphics pixel-setting routine
INCLUDE	a$setup.inc
; Copyright 1992-1994 TeraTech, Inc. All rights reserved.
; 100 Park Ave., Suite 360, Rockville MD 20850
; (800)447-9120, (301)762-8185, Fax: (301)762-8185
;
; Copyright (c) 1991-1992 H.C.S.F., Inc. All rights reserved.
; (C) Copyright 1989-1991 Hammerly Computer Services Inc.
;
; DECLARE SUB SETPIXEL(COL%, ROW%, COLOR%)

?Code	HCS_VIDG
?Proc	SETPIXEL
	push	bp
	xor	ax, ax
	mov	bp, sp
	mov	es, ax			; BIOS data area
	mov	al, es:[0449h]		; get current video mode
	cmp	al, 13			; are we in EGA or VGA graphics?

	JB	CGAgraphics		; no, assume CGA (out of range jmp)

	cmp	al, 19			; VGA low-res mode?
	je	VGAlowRes		;   yes, special case

	mov	bx, [bp+8]		; Y coordinate
	mov	ax, [bx]
	mov	bx, [bp+10]		; X coordinate
	mov	cl, 4
	mov	bx, [bx]
	;mov	cl, 4
	shl	ax, cl
	mov	dx, ax
	add	ax, ax			;shl	ax, 1
	add	ax, ax			;shl	ax, 1
	add	ax, dx
	mov	cl, bl
	not	cl
	and	cl, 7
	shr	bx, 1
	shr	bx, 1
	shr	bx, 1
	add	bx, ax			; pixel offset
	mov	ax, 0A000h
	mov	es, ax			; video segment
	mov	dx, 03CEh
	mov	ah, 1
	shl	ah, cl			; bit mask
	mov	al, 8
	out	dx, ax
	mov	ax, 0205h		; set mode
	out	dx, ax
	mov	ax, 3
	out	dx, ax
	mov	al, es:[bx]		; latch bit planes
	mov	bp, [bp+6]		; COLOUR value
	mov	al, ds:[bp]
	mov	es:[bx], al		; set pixel
	mov	ax, 0FF08h		; restore mode defaults
	out	dx, ax
	mov	ax, 5
	out	dx, ax
	mov	al, 3
	out	dx, ax
Done:
	pop	bp
	ret	6

	EVEN
VGAlowRes:
	mov	bx, [bp+6]		; COLOUR value
	mov	ch, [bx]
	mov	bx, [bp+10]		; X coordinate
	mov	ax, [bx]
	mov	bx, [bp+8]		; Y coordinate
	mov	cl, 6
	mov	bx, [bx]
	;mov	cl, 6
	shl	bx, cl
	mov	dx, bx
	add	bx, bx			;shl	bx, 1
	add	bx, bx			;shl	bx, 1
	add	bx, dx
	add	bx, ax
	mov	ax, 0A000h		; video segment
	mov	es, ax
	mov	es:[bx], ch		; set pixel
	jmp	Done

	EVEN
CGAgraphics:
	push	si
	push	di
	mov	si, [bp+10]
	mov	dx, [si]		; column
	mov	si, [bp+8]
	mov	bx, [si]		; row
	mov	si, [bp+6]
	mov	al, [si]		; color
	mov	di, bx
	mov	si, bx
	add	si, si			;shl	si, 1
	add	si, si			;shl	si, 1
	add	si, bx
	add	si, si			;shl	si, 1
	add	si, si			;shl	si, 1
	add	si, si			;shl	si, 1
	shr	di, 1			; even pixel?
	jnc	GotBoundary		;   yes
	add	si,8152 		; add offset for odd pixels
GotBoundary:
	cmp	byte ptr es:[0449h], 6	; 640x200 graphics?
	jne	CGAlow			;   no, assume 320x200
	mov	cx, 8007h
	and	cl, dl
	shr	dx, 1
	shr	dx, 1
	shr	dx, 1
	add	si, dx
	ror	al, 1

CGAplot:
	shr	ch, cl
	shr	al, cl
	and	al, ch
	not	ch
	mov	di, 0B800h		; screen segment
	mov	es, di
	mov	cl, es:[si]		; get current screen info
	and	cl, ch			; mask out our pixel
	or	al, cl			; set the pixel appropriately
	mov	es:[si], al		; put the info on the screen
	pop	di
	pop	si
	jmp	Done

	EVEN
CGAlow:
	mov	cx, 0C003h
	and	cl, dl
	shr	dx, 1
	shr	dx, 1
	add	si, dx
	ror	al, 1
	ror	al, 1
	shl	cl, 1
	jmp	CGAplot
?EndP	SETPIXEL

?End
